#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_SeniorItemDropCFG.h"
std::auto_ptr<Fish_SeniorItemDropCFG> Fish_SeniorItemDropCFG::msSingleton(nullptr);

int Fish_SeniorItemDropCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_SeniorItemDropCFGData* Fish_SeniorItemDropCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_SeniorItemDropCFGData>& Fish_SeniorItemDropCFG::GetMapData()
{
	return mMapData;
}

void Fish_SeniorItemDropCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_SeniorItemDropCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_SeniorItemDropCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mItemId = element->IntAttribute("ItemId");
		data.mWeight = element->IntAttribute("Weight");
		{
			const char* Turret = element->Attribute("Turret");
			std::vector<std::string> vecTurret;
			boost::split(vecTurret, Turret, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecTurret.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecTurret[i].c_str(), &temp))
				{
					data.mTurret.push_back(temp);
				}
			}
		}
		{
			const char* DropCount = element->Attribute("DropCount");
			std::vector<std::string> vecDropCount;
			boost::split(vecDropCount, DropCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecDropCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecDropCount[i].c_str(), &temp))
				{
					data.mDropCount.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_SeniorItemDropCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_SeniorItemDropCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_SeniorItemDropCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_SeniorItemDropCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_SeniorItemDropCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "ItemId", data.mItemId);
		LuaCfgHelper::readInt(L, "Weight", data.mWeight);
		LuaCfgHelper::readVectorInt(L, "Turret", data.mTurret);
		LuaCfgHelper::readVectorInt(L, "DropCount", data.mDropCount);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_SeniorItemDropCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_SeniorItemDropCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_SeniorItemDropCFG* Fish_SeniorItemDropCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_SeniorItemDropCFG());
	}
	return msSingleton.get();
}

void Fish_SeniorItemDropCFG::Release()
{
	msSingleton.reset(nullptr);
}
